DATADU ; DATADUMP filespec<CR>
 ;
 ; A line printer spooler designed to work in conjunction
 ; with the program GPRINT/CMD.
 ; (c) 1981 by John J. Schultz, placed in public domain.
 ;
 ; This program is designed to drop all printer output on
 ; a file specified by 'filespec'. The file 'filespec'
 ; will not be opened until the first character is
 ; received by this driver. All printer output will be
 ; written sequentially into the file until an ascii
 ; null (00H) is received, which closes the file and
 ; restores the original driver. WARNING: If the user
 ; should re-boot the computer before the driver receives
 ; an ascii null (00H) signal, the file will remain open
 ; on the disk and will not contain all of the data. In
 ; this state, the DOS will give an improper free granule
 ; reading and an attempt to kill the file while it is
 ; still open in the directory will only further worsten
 ; this condition .... Please be EXTREMELY careful when
 ; writing programs that use this program.
 ;
 ;
 INIT	EQU	4420H
 VERF	EQU	443CH
 CLOSE	EQU	4428H
 ERROR	EQU	4409H
 HIMEM	EQU	4049H
 LPDRVE	EQU	4026H
 DOS	EQU	402DH
 DISPA	EQU	0033H
 MEM16K	EQU	7C00H
 MEM32K	EQU	0BC00H
 MEM48K	EQU	0FC00H
 	ORG	MEM48K
 START	LD	B,0
 	LD	DE,DCB
 LOOP1	LD	A,(HL)
 	LD	(DE),A
 	CP	0DH
 	JR	Z,CONT1
 	INC	HL
 	INC	DE
 	INC	B
 	JR	LOOP1
 CONT1	LD	A,B
 	OR	A
 	JR	NZ,CONT2
 	LD	HL,NFSPC
 	CALL	DISPHL
 	JP	DOS
 CONT2	LD	HL,START-1
 	LD	(HIMEM),HL
 	LD	HL,(LPDRVE)
 	LD	(NMDRVE),HL
 	LD	HL,START2
 	LD	(LPDRVE),HL
 	XOR	A
 	LD	(FLAG1),A
 	CALL	ZBUFF
 	JP	DOS
 START2	LD	A,(FLAG1)
 	OR	A
 	JR	NZ,CONT3
 	LD	DE,DCB
 	LD	HL,BUFFER
 	LD	B,0
 	CALL	INIT
 	JR	NZ,DISERR
 	LD	A,1
 	LD	(FLAG1),A
 	LD	HL,BUFFER
 	LD	(BUFPTR),HL
 CONT3	LD	A,C
 	OR	A
 	JR	NZ,CONT4
 	CALL	WRITE
 	CALL	CLOSE2
 	LD	HL,(NMDRVE)
 	LD	(LPDRVE),HL
 	RET
 CONT4	LD	HL,(BUFPTR)
 	LD	(HL),A
 	INC	HL
 	LD	(BUFPTR),HL
 	LD	A,(COUNT)
 	DEC	A
 	LD	(COUNT),A
 	RET	NZ
 	CALL	WRITE
 	CALL	ZBUFF
 	RET
 WRITE	LD	DE,DCB
 	CALL	VERF
 	JR	NZ,DISERR
 	RET
 ZBUFF	LD	HL,BUFFER
 	LD	(BUFPTR),HL
 	LD	B,0
 LOOP2	LD	(HL),0
 	INC	HL
 	DJNZ	LOOP2
 	RET
 DISERR	OR	0C0H
 	CALL	ERROR
 	LD	DE,DCB
 	CALL	CLOSE
 	RET
 CLOSE2	LD	DE,DCB
 	CALL	CLOSE
 	JR	NZ,DISERR
 	RET
 DISPHL	LD	A,(HL)
 	PUSH	AF
 	AND	7FH
 	CALL	DISPA
 	POP	AF
 	INC	HL
 	BIT	7,A
 	RET	NZ
 	JR	DISPHL
 FLAG1	DEFB	0
 COUNT	DEFB	0
 BUFPTR	DEFW	BUFFER
 NMDRVE	DEFW	0
 BUFFER	DEFS	256
 DCB	DEFS	50
 NFSPC	DEFM	'No filespec'
 	DEFB	8DH
 	END	START
